﻿// Copyright (c) 2006 Google Inc.
// All rights reserved
// 
// This file is part of the Google Desktop SDK and may be freely copied and used.
// To download the latest version of the SDK please visit 
// http://desktop.google.com/

var timer_handle =null;
var RENDEREDHTML = '';

var DEFAULT_HTML_STYLE = "<html>" +
  // Set the style (fonts, sizes, etc)
  "<style type=\"text/css\">" +
  "<!--" +
  "body,td,th {" +
  "	 font-family: Geneva, Arial, Helvetica, sans-serif;" +
  "	 font-size: 12px;" +
  "	 color: #333333;" +
  "}" +
  "body {" +
  "	 margin-left: 0px;" +
  "	 margin-top: 0px;" +
  "	 margin-right: 0px;" +
  "	 margin-bottom: 0px;" +

  // Remove scrollbar from side
  "  overflow: auto;" +
  "}" +
  "-->" +
  "</style>" +

  // Disable right click
  "<script language=\"Javascript\">" +
  "  document.oncontextmenu=new Function(\"return false\")" +
  "</script>";
  
  
  /*
var DETAILS_HTML = DEFAULT_HTML_STYLE +
  "<body>" +
  CLICK_AN_ITEM + "<p>" +
  "<a href=\"\" onclick=\"window.external.onItemClick('A'); return false;\">" + ITEM_A + "</a><br>" +
  "<a href=\"\" onclick=\"window.external.onItemClick('B'); return false;\">" + ITEM_B + "</a><br>" +
  "<a href=\"\" onclick=\"window.external.onItemClick('C'); return false;\">" + ITEM_C + "</a><br>" +
  "</p></body>" +
  "</html>";
*/

function onOpenOptionsClick() 
{
  pluginHelper.showOptionsDialog();
}

function PNRStatus()
{
	var RetVal = DEFAULT_HTML_STYLE +
	 "<body>" +
	CLICK_AN_ITEM + "<p>" +
	"<a href=\"\" onclick=\"window.external.onItemClick('A'); return false;\">" + ITEM_A + "</a><br>" +
	"<a href=\"\" onclick=\"window.external.onItemClick('B'); return false;\">" + ITEM_B + "</a><br>" +
	"<a href=\"\" onclick=\"window.external.onItemClick('C'); return false;\">" + ITEM_C + "</a><br>" +
	"</p></body>" +
	"</html>";
	return RetVal;
}

function onTextClick() 
{
  // Create the details view and set its content. Specifying 'undefined' in 
  // setContent makes it such that no time is displayed in the details view
  var htmlDetailsView = new DetailsView();
  htmlDetailsView.html_content = true;
  //htmlDetailsView.setContent( "", undefined, DETAILS_HTML, false, 0);
  htmlDetailsView.setContent( "", undefined, PNRStatus(), false, 0);

  // In order to have two way communication with the HTML details view, we 
  // need to set an external object that can receive events. This is called 
  // from the HTML using the javascript "window.external.onItemClick(text);".
  var externalObject = new Object();
  externalObject.onItemClick = onItemClick;
  htmlDetailsView.external = externalObject;
  
  //view.alert(htmlDetailsView.innerHTML);

  // Show the details view
  pluginHelper.showDetailsView(htmlDetailsView, DETAILS_VIEW_TITLE,  gddDetailsViewFlagToolbarOpen, onDetailsViewFeedback);
   
}

function onRender() 
{
  // Create the details view and set its content. Specifying 'undefined' in 
  // setContent makes it such that no time is displayed in the details view
  var htmlDetailsView = new DetailsView();
  htmlDetailsView.html_content = true;
  //htmlDetailsView.setContent( "", undefined, DETAILS_HTML, false, 0);
  htmlDetailsView.setContent( "", undefined, RENDEREDHTML, false, 0);

  // In order to have two way communication with the HTML details view, we 
  // need to set an external object that can receive events. This is called 
  // from the HTML using the javascript "window.external.onItemClick(text);".
  //var externalObject = new Object();
  //externalObject.onItemClick = onItemClick;
 // htmlDetailsView.external = externalObject;
 //htmlDetailsView.enabled = true;
  
  //view.alert(htmlDetailsView.innerHTML);

  // Show the details view
  pluginHelper.showDetailsView(htmlDetailsView, DETAILS_VIEW_TITLE,  gddDetailsViewFlagToolbarOpen, onDetailsViewFeedback);
   
}

function OnAppClose()
{
	if(timer_handle != null)
	{
		clearTimeout(timer_handle);
	}
}

function OnAppStart()
{
	//view.alert("Application Started.");
	if(timer_handle != null)
	{
		clearTimeout(timer_handle);
	}
	
	var IsTimerEnabled = (options.getValue("IsCheckboxEnabled") == "ON" );
	if(IsTimerEnabled)
	{
		var Interval = options.getValue("PollInterval") * 60000;
		timer_handle = setTimeout("OnTimer(" +Interval+")", Interval);
	}
	PNRData.value = options.getValue("PNRNo");
	//PNRNo = options.getValue("PNRNo");
	onRequestStatus();
}

function OnTimer(Inter)
{
	//view.alert("Sending Request..");
	
	onRequestStatus();
	
	timer_handle = setTimeout("OnTimer(" + Inter + ")", Inter);
}

function onItemClick(text) 
{
  // Display which item was clicked on
  view.alert(text);
 

  // Close the details view
  pluginHelper.CloseDetailsView();
}

function onDetailsViewFeedback(detailsViewFlags) 
{
  if (detailsViewFlags == gddDetailsViewFlagNone) 
  {
    // User closed the details view
  }
  else if (detailsViewFlags == gddDetailsViewFlagToolbarOpen) 
  {
    // User clicked on the title of the details view
  }
}

//var PNR_URL = "http://www.google.com/intl/en/images/logo.gif";
var PNR_URL = "http://www.indianrail.gov.in/cgi_bin/inet_pnrstat_cgi.cgi";
var logoRequest_ = null;

function onRequestStatus() 
{
  var PNRNo = PNRData.value;
  if(PNRNo.length != 10)
  {
	lblStatus.innerText = "Please enter PNR No (10 Digits)";
	 return false;
  }
  lblStatus.innerText = "Please wait..";
  lblStatus2.innerText = "";
  lblStatus3.innerText = "";
  lblStatus3.innerText = "";
  lblStatus4.innerText = "";
  lblStatus5.innerText = "";
  lblStatus6.innerText = "";
  
  options.putValue("PNRNo", PNRNo);
    	
  // Start to Send The Request
  logoRequest_ = new XMLHttpRequest();
  try 
  {
    logoRequest_.open("POST", PNR_URL, true);
  }
  catch (e) 
  {
    // Catch invalid URLs
    //statusLabel.innerText = FAILED;
    view.alert("FAILED");
    logoRequest_ = null;
    return;
  }

  // Set the callback for when the downloading is completed (or failed)
  logoRequest_.onreadystatechange = onLogoData;

  // Start the download
  try 
  {
    var lccp1 = PNRNo.substr(0,3);
    var lccp2 = PNRNo.substr(3);
    //view.alert(lccp1 + "\n\n" + lccp2)
    logoRequest_.send("lccp_pnrno1=" + lccp1 + "&lccp_pnrno2=" + lccp2);
  }
  catch (e) 
  {
    // Catch errors sending the request
    //statusLabel.innerText = FAILED;
    view.alert("FAILED");
    logoRequest_ = null;
    return;
  }
}

function onLogoData() 
{
	var RHtml = "";
  // Verify that the response completed
  if (logoRequest_.readyState != 4)
    return;

  // Verify that the response was successful
  if (logoRequest_.status != 200) 
  {
	RENDEREDHTML = "<html><body><center><h3>FAILED</h3></center></body></html>";
    //statusLabel.innerText = FAILED;
    logoRequest_ = null;
    return;
  }

  // Obtain the stream of image data and set it as the image. If you were
  // just downloading text, you could use .responseText to get the text content
  // of the URL you specified.
  try
  {
	RENDEREDHTML = logoRequest_.responseText;
  }
  catch(e)
  {
  }
  DisplayStatus();
  // Destroy the XMLHttpRequest object since it isn't being used anymore
  logoRequest_ = null;
}

function DisplayStatus()
{
	var nTemp = RENDEREDHTML.toString().toUpperCase();
	var i = 0;
	for(i=1;i<=6;i++)
	{
		var Message = "";
		var Pos1 = nTemp.indexOf("<B>PASSENGER " + i + "</B>");
		var Pos2 = -1;
		if(Pos1 > -1)
		{
			nTemp = nTemp.substr(Pos1 + 20);
			Pos1 = nTemp.indexOf("<B>");
			Pos2 = nTemp.indexOf("</B>");
			var kTemp = nTemp.substr(Pos1+3, (Pos2-Pos1)-3 );
			//view.alert(kTemp + "\n\n" + nTemp);

			nTemp = nTemp.substr(Pos2+4);
			Pos1 = nTemp.indexOf("<B>");
			Pos2 = nTemp.indexOf("</B>");
			//view.alert(Pos1);
			//view.alert(Pos2);
			var lTemp = nTemp.substr(Pos1+3, (Pos2-Pos1)-3 );
			//view.alert(lTemp + "\n\n" + nTemp);

			Message = "Passenger" + i + "    " + lTemp + "    " + kTemp;
			//view.alert(Message);
		}
		switch(i)
		{
			case 1:
			{
				//view.alert("'" + Message + "'");
				if(Message == "")
				{
					Message = "Sorry, Please check the Details";
				}			
				lblStatus.innerText = Message;
				break;
			}
			case 2:
			{
				lblStatus2.innerText = Message;
				break;
			}
			case 3:
			{
				lblStatus3.innerText = Message;
				break;
			}
			case 4:
			{
				lblStatus4.innerText = Message;
				break;
			}
			case 5:
			{
				lblStatus5.innerText = Message;
				break;
			}
			case 6:
			{
				lblStatus6.innerText = Message;
				break;
			}															
		}

	}
}








